SystemOrganization addCategory: #BugFinderExample!

Exception subclass: #ElementTooBig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BugFinderExample'!

Exception subclass: #EmptyBox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BugFinderExample'!

Object subclass: #Box
	instanceVariableNames: 'capacity elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BugFinderExample'!

!Box methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/14/2011 18:17'!
add: aBoxElement
	(aBoxElement size > capacity)
		ifTrue: [ ElementTooBig signal: 'Element does not fit into box' ]
		ifFalse: [
			elements add: aBoxElement.
			capacity := capacity - (aBoxElement size)
		].! !

!Box methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/14/2011 15:01'!
capacity: anInteger
	capacity := anInteger.! !

!Box methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/19/2011 22:07'!
firstElement
	elements isEmpty
		ifTrue: [ EmptyBox signal: 'box is empty' ]
		ifFalse: [ ^ elements first ].! !

!Box methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/19/2011 22:07'!
firstElementBuggy
	^ elements first.! !

!Box methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/14/2011 15:00'!
initialize
	elements := OrderedCollection new.! !

!Box methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/19/2011 14:17'!
printString
	^ super printString.! !

!Box methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/19/2011 22:03'!
removeBiggestElement
	| biggest biggestIndex |
	elements isEmpty
		ifTrue: [ EmptyBox signal: 'box is empty' ]
		ifFalse: [ 
			biggest := 0.
			biggestIndex := 0.
			elements
				do: [ :el | 
					el size > biggest
						ifTrue: [ 
							biggest := el size.
							biggestIndex := elements indexOf: el ] ].
			^ elements removeAtIndex: biggestIndex ]! !

!Box methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/19/2011 22:03'!
removeBiggestElementBuggy
	| biggest biggestIndex |
	biggest := 0.
	biggestIndex := 0.
	elements
		do: [ :el | 
			el size > biggest
				ifTrue: [ 
					biggest := el size.
					biggestIndex := elements indexOf: el ] ].
	^ elements removeAtIndex: biggestIndex! !

!Box methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/19/2011 22:03'!
removeSmallestElement
	| smallest smallestIndex |
	elements isEmpty
		ifTrue: [ EmptyBox signal: 'box is empty' ]
		ifFalse: [ 
			smallest := elements first size.
			smallestIndex := 1.
			elements
				do: [ :el | 
					el size < smallest
						ifTrue: [ 
							smallest := el size.
							smallestIndex := elements indexOf: el ] ].
			^ elements removeAtIndex: smallestIndex ]! !

!Box methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/19/2011 22:03'!
removeSmallestElementBuggy
	| smallest smallestIndex |
	smallest := elements first size.
	smallestIndex := 1.
	elements
		do: [ :el | 
			el size < smallest
				ifTrue: [ 
					smallest := el size.
					smallestIndex := elements indexOf: el ] ].
	^ elements removeAtIndex: smallestIndex! !

Object subclass: #BoxElement
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BugFinderExample'!

!BoxElement methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/14/2011 15:03'!
size
	^ size.! !

!BoxElement methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/14/2011 15:03'!
size: anInteger
	size := anInteger.! !

Object subclass: #BugFinderExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BugFinderExample'!

!BugFinderExample methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/19/2011 20:35'!
fullBox
	| box |
	box := Box new
		capacity: 55;
		add: ( BoxElement new size: 3; yourself );
		add: ( BoxElement new size: 10; yourself );
		add: ( BoxElement new size: 4; yourself );
		add: ( BoxElement new size: 1; yourself );
		add: ( BoxElement new size: 2; yourself );
		add: ( BoxElement new size: 8; yourself );
		add: ( BoxElement new size: 7; yourself );
		add: ( BoxElement new size: 9; yourself );
		add: ( BoxElement new size: 6; yourself );
		add: ( BoxElement new size: 5; yourself );
		yourself.
	^ BugFinder tryUnarySelectors: box iterations: 100! !
